/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-1-Va_Acpi.aml, Sun Dec 17 00:12:00 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000172 (370)
 *     Revision         0x01
 *     Checksum         0x58
 *     OEM ID           "VaRef"
 *     OEM Table ID     "Va_Acpi"
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */
DefinitionBlock ("", "SSDT", 1, "VaRef", "Va_Acpi", 0x00003000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (MDBG, MethodObj)    // Imported: 1 Arguments

    Scope (\_SB.PCI0)
    {
        Device (IEIT)
        {
            Name (_HID, EisaId ("INT5400"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02"))  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            OperationRegion (SGPE, SystemIO, 0x0400, 0x44)
            Field (SGPE, WordAcc, NoLock, Preserve)
            {
                Offset (0x20), 
                    ,   2, 
                SWGS,   1, 
                Offset (0x28), 
                    ,   2, 
                SWGE,   1, 
                Offset (0x42), 
                    ,   1, 
                SWGC,   1
            }

            OperationRegion (SMIP, SystemIO, 0xB2, 0x02)
            Field (SMIP, WordAcc, NoLock, Preserve)
            {
                SMIT,   8, 
                SMID,   8
            }

            OperationRegion (VA_M, SystemMemory, 0xFFFF55AA, 0x0100)
            Field (VA_M, AnyAcc, NoLock, Preserve)
            {
                SIGN,   64, 
                SIZE,   32, 
                OVER,   32, 
                SUBF,   32, 
                EITD,   32, 
                FNCD,   32, 
                VVER,   32, 
                ATTR,   32, 
                SINF,   32, 
                Offset (0x40), 
                EITI,   1, 
                EITF,   7, 
                EITP,   8, 
                Offset (0x44), 
                DAT0,   32, 
                DAT1,   32, 
                SPD0,   32, 
                SPD1,   32, 
                Offset (0x58), 
                VISI,   32, 
                VIFC,   32, 
                VIST,   32, 
                VILN,   32, 
                VID0,   32, 
                VID1,   32, 
                VID2,   32, 
                VID3,   32
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (0x0F)
            }

            Method (ADDR, 0, NotSerialized)
            {
                Return (0x55AA55AA)
            }

            Method (SCIT, 0, NotSerialized)
            {
                Return (0x0442)
            }

            Method (SCIB, 0, NotSerialized)
            {
                Return (One)
            }

            Method (EITV, 0, NotSerialized)
            {
                Store (0x30, SMIT)
            }
        }
    }
}

