/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-2-SataPri.aml, Sun Dec 17 00:12:00 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000C39 (3129)
 *     Revision         0x01
 *     Checksum         0xCE
 *     OEM ID           "INTEL "
 *     OEM Table ID     "SataPri"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */
DefinitionBlock ("", "SSDT", 1, "INTEL ", "SataPri", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (GDMA, MethodObj)    // 2 Arguments
    External (GPI0, MethodObj)    // 4 Arguments
    External (MDBG, MethodObj)    // Imported: 1 Arguments
    External (SDMA, MethodObj)    // 3 Arguments
    External (SFLG, MethodObj)    // 5 Arguments
    External (SPIO, MethodObj)    // 3 Arguments

    Scope (\_SB.PCI0)
    {
        Device (SATA)
        {
            OperationRegion (CMOS, SystemIO, 0x70, 0x04)
            Field (CMOS, ByteAcc, NoLock, Preserve)
            {
                IDX0,   7, 
                Offset (0x01), 
                DAT0,   8, 
                IDX1,   7, 
                Offset (0x03), 
                DAT1,   8
            }

            IndexField (IDX1, DAT1, AnyAcc, NoLock, Preserve)
            {
                Offset (0x25), 
                PFT0,   1, 
                PIE0,   1, 
                PPE0,   1, 
                PDE0,   1, 
                PFT1,   1, 
                PIE1,   1, 
                PPE1,   1, 
                PDE1,   1, 
                PRT0,   2, 
                    ,   2, 
                PIP0,   2, 
                PSIT,   1, 
                Offset (0x27), 
                SFT0,   1, 
                SIE0,   1, 
                SPE0,   1, 
                SDE0,   1, 
                SFT1,   1, 
                SIE1,   1, 
                SPE1,   1, 
                SDE1,   1, 
                SRT0,   2, 
                    ,   2, 
                SIP0,   2, 
                SSIT,   1, 
                Offset (0x29)
            }

            OperationRegion (IDER, PCI_Config, 0x40, 0x20)
            Field (IDER, AnyAcc, NoLock, Preserve)
            {
                    ,   15, 
                PIDE,   1, 
                    ,   15, 
                SIDE,   1, 
                PRT1,   2, 
                PIP1,   2, 
                SRT1,   2, 
                SIP1,   2, 
                Offset (0x08), 
                UDM0,   1, 
                UDM1,   1, 
                UDM2,   1, 
                UDM3,   1, 
                Offset (0x0A), 
                PCT0,   2, 
                    ,   2, 
                PCT1,   2, 
                Offset (0x0B), 
                SCT0,   2, 
                    ,   2, 
                SCT1,   2, 
                Offset (0x14), 
                PCB0,   1, 
                PCB1,   1, 
                SCB0,   1, 
                SCB1,   1, 
                PCCR,   2, 
                SCCR,   2, 
                    ,   4, 
                PUM0,   1, 
                PUM1,   1, 
                SUM0,   1, 
                SUM1,   1, 
                PSIG,   2, 
                SSIG,   2, 
                UMT0,   1, 
                UMT1,   1, 
                UMT2,   1, 
                UMT3,   1
            }

            Name (_ADR, 0x001F0002)  // _ADR: Address
            Device (PRID)
            {
                Name (_ADR, Zero)  // _ADR: Address
                Name (TDM0, Zero)
                Name (TPI0, Zero)
                Name (TDM1, Zero)
                Name (TPI1, Zero)
                Method (_GTM, 0, NotSerialized)  // _GTM: Get Timing Mode
                {
                    Name (PBUF, Buffer (0x14)
                    {
                        /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                        /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                        /* 0010 */  0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateDWordField (PBUF, Zero, PIO0)
                    CreateDWordField (PBUF, 0x04, DMA0)
                    CreateDWordField (PBUF, 0x08, PIO1)
                    CreateDWordField (PBUF, 0x0C, DMA1)
                    CreateDWordField (PBUF, 0x10, FLAG)
                    Store (GPI0 (PFT0, PDE0, PRT0, PIP0), PIO0)
                    If (And (PSIT, One))
                    {
                        Store (GPI0 (PFT1, PDE1, PRT1, PIP1), PIO1)
                    }
                    Else
                    {
                        Store (GPI0 (PFT1, PDE1, PRT0, PIP0), PIO1)
                    }

                    Store (GDMA (UDM0, PUM0), DMA0)
                    If (LAnd (LEqual (DMA0, 0x14), UMT0))
                    {
                        Store (0x0F, DMA0)
                    }

                    If (LGreater (DMA0, PIO0))
                    {
                        Store (PIO0, DMA0)
                    }

                    Store (GDMA (UDM1, PUM1), DMA1)
                    If (LAnd (LEqual (DMA1, 0x14), UMT1))
                    {
                        Store (0x0F, DMA1)
                    }

                    If (LGreater (DMA1, PIO1))
                    {
                        Store (PIO1, DMA1)
                    }

                    Store (SFLG (PIE0, UDM0, PIE1, UDM1, One), FLAG)
                    Return (PBUF)
                }

                Method (_STM, 3, NotSerialized)  // _STM: Set Timing Mode
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    CreateWordField (Arg1, 0x6A, RPS0)
                    CreateWordField (Arg1, 0x80, IOM0)
                    CreateWordField (Arg1, 0xB0, DMM0)
                    CreateWordField (Arg2, 0x6A, RPS1)
                    CreateWordField (Arg2, 0x80, IOM1)
                    CreateWordField (Arg2, 0xB0, DMM1)
                    Name (IOTM, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateByteField (IOTM, Zero, RCT)
                    CreateByteField (IOTM, One, ISP)
                    CreateByteField (IOTM, 0x02, FAST)
                    CreateByteField (IOTM, 0x03, DMAE)
                    CreateByteField (IOTM, 0x04, TPIO)
                    Name (DMAT, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateByteField (DMAT, Zero, PCT)
                    CreateByteField (DMAT, One, PCB)
                    CreateByteField (DMAT, 0x02, UDMT)
                    CreateByteField (DMAT, 0x03, UDME)
                    CreateByteField (DMAT, 0x04, TDMA)
                    Store (SPIO (PIO0, RPS0, IOM0), IOTM)
                    If (Or (DMAE, FAST))
                    {
                        Store (RCT, PRT0)
                        Store (ISP, PIP0)
                        Store (FAST, PFT0)
                        Store (DMAE, PDE0)
                        Store (TPIO, TPI0)
                    }

                    Store (SPIO (PIO1, RPS1, IOM1), IOTM)
                    If (Or (DMAE, FAST))
                    {
                        Store (FAST, PFT1)
                        Store (DMAE, PDE1)
                        Store (TPIO, TPI1)
                        If (And (PSIT, One))
                        {
                            Store (RCT, PRT1)
                            Store (ISP, PIP1)
                        }
                        Else
                        {
                            Store (RCT, PRT0)
                            Store (ISP, PIP0)
                        }
                    }

                    If (And (FLAG, One))
                    {
                        Store (SDMA (DMA0, RPS0, DMM0), DMAT)
                        Store (PCT, PCT0)
                        Store (PCB, PCB0)
                        Store (UDME, UDM0)
                        Store (UDMT, PUM0)
                        Store (TDMA, TDM0)
                    }
                    Else
                    {
                        Store (Zero, UDM0)
                    }

                    If (And (FLAG, 0x04))
                    {
                        Store (SDMA (DMA1, RPS1, DMM1), DMAT)
                        Store (PCT, PCT1)
                        Store (PCB, PCB1)
                        Store (UDME, UDM1)
                        Store (UDMT, PUM1)
                        Store (TDMA, TDM1)
                    }
                    Else
                    {
                        Store (Zero, UDM1)
                    }

                    If (And (FLAG, 0x02))
                    {
                        Store (One, PIE0)
                    }

                    If (And (FLAG, 0x08))
                    {
                        Store (One, PIE1)
                    }
                }

                Device (MAST)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA0, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03,
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF             
                        })
                        CreateByteField (ATA0, One, PIO0)
                        CreateByteField (ATA0, 0x08, DMA0)
                        Store (TPI0, PIO0)
                        Or (PIO0, 0x08, PIO0)
                        If (And (UDM0, One))
                        {
                            Store (TDM0, DMA0)
                            Or (DMA0, 0x40, DMA0)
                        }
                        Else
                        {
                            Store (TPI0, DMA0)
                            If (LNotEqual (DMA0, Zero))
                            {
                                Subtract (DMA0, 0x02, DMA0)
                            }

                            Or (DMA0, 0x20, DMA0)
                        }

                        Return (ATA0)
                    }
                }

                Device (SLAV)
                {
                    Name (_ADR, One)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA1, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03,
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF             
                        })
                        CreateByteField (ATA1, One, PIO1)
                        CreateByteField (ATA1, 0x08, DMA1)
                        Store (TPI1, PIO1)
                        Or (PIO1, 0x08, PIO1)
                        If (And (UDM1, One))
                        {
                            Store (TDM1, DMA1)
                            Or (DMA1, 0x40, DMA1)
                        }
                        Else
                        {
                            Store (TPI1, DMA1)
                            If (LNotEqual (DMA1, Zero))
                            {
                                Subtract (DMA1, 0x02, DMA1)
                            }

                            Or (DMA1, 0x20, DMA1)
                        }

                        Return (ATA1)
                    }
                }
            }

            Device (SECD)
            {
                Name (_ADR, One)  // _ADR: Address
                Name (TDM0, Zero)
                Name (TPI0, Zero)
                Name (TDM1, Zero)
                Name (TPI1, Zero)
                Name (DMT1, Buffer (0x05)
                {
                     0x00, 0x00, 0x00, 0x00                         
                })
                Name (DMT2, Buffer (0x05)
                {
                     0x00, 0x00, 0x00, 0x00                         
                })
                Name (POT1, Buffer (0x05)
                {
                     0x00, 0x00, 0x00, 0x00                         
                })
                Name (POT2, Buffer (0x05)
                {
                     0x00, 0x00, 0x00, 0x00                         
                })
                Name (STMI, Buffer (0x14)
                {
                    /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                    /* 0010 */  0x00, 0x00, 0x00, 0x00                         
                })
                Method (_GTM, 0, NotSerialized)  // _GTM: Get Timing Mode
                {
                    Name (PBUF, Buffer (0x14)
                    {
                        /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                        /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                        /* 0010 */  0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateDWordField (PBUF, Zero, PIO0)
                    CreateDWordField (PBUF, 0x04, DMA0)
                    CreateDWordField (PBUF, 0x08, PIO1)
                    CreateDWordField (PBUF, 0x0C, DMA1)
                    CreateDWordField (PBUF, 0x10, FLAG)
                    Store (GPI0 (SFT0, SDE0, SRT0, SIP0), PIO0)
                    If (And (SSIT, One))
                    {
                        Store (GPI0 (SFT1, SDE1, SRT1, SIP1), PIO1)
                    }
                    Else
                    {
                        Store (GPI0 (SFT1, SDE1, SRT0, SIP0), PIO1)
                    }

                    Store (GDMA (UDM2, SUM0), DMA0)
                    If (LAnd (LEqual (DMA0, 0x14), UMT2))
                    {
                        Store (0x0F, DMA0)
                    }

                    If (LGreater (DMA0, PIO0))
                    {
                        Store (PIO0, DMA0)
                    }

                    Store (GDMA (UDM3, SUM1), DMA1)
                    If (LAnd (LEqual (DMA1, 0x14), UMT3))
                    {
                        Store (0x0F, DMA1)
                    }

                    If (LGreater (DMA1, PIO1))
                    {
                        Store (PIO1, DMA1)
                    }

                    Store (SFLG (SIE0, UDM2, SIE1, UDM3, One), FLAG)
                    Return (PBUF)
                }

                Method (_STM, 3, NotSerialized)  // _STM: Set Timing Mode
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    Store (Arg0, STMI)
                    CreateWordField (Arg1, 0x6A, RPS0)
                    CreateWordField (Arg1, 0x80, IOM0)
                    CreateWordField (Arg1, 0xB0, DMM0)
                    CreateWordField (Arg2, 0x6A, RPS1)
                    CreateWordField (Arg2, 0x80, IOM1)
                    CreateWordField (Arg2, 0xB0, DMM1)
                    Name (IOTM, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateByteField (IOTM, Zero, RCT)
                    CreateByteField (IOTM, One, ISP)
                    CreateByteField (IOTM, 0x02, FAST)
                    CreateByteField (IOTM, 0x03, DMAE)
                    CreateByteField (IOTM, 0x04, TPIO)
                    Name (DMAT, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                         
                    })
                    CreateByteField (DMAT, Zero, PCT)
                    CreateByteField (DMAT, One, PCB)
                    CreateByteField (DMAT, 0x02, UDMT)
                    CreateByteField (DMAT, 0x03, UDME)
                    CreateByteField (DMAT, 0x04, TDMA)
                    Store (SPIO (PIO0, RPS0, IOM0), IOTM)
                    If (Or (DMAE, FAST))
                    {
                        Store (RCT, SRT0)
                        Store (ISP, SIP0)
                        Store (FAST, SFT0)
                        Store (DMAE, SDE0)
                        Store (TPIO, TPI0)
                    }

                    Store (SPIO (PIO1, RPS1, IOM1), IOTM)
                    Store (IOTM, POT2)
                    If (Or (DMAE, FAST))
                    {
                        Store (FAST, SFT1)
                        Store (DMAE, SDE1)
                        Store (TPIO, TPI1)
                        If (And (SSIT, One))
                        {
                            Store (RCT, SRT1)
                            Store (ISP, SIP1)
                        }
                        Else
                        {
                            Store (RCT, SRT0)
                            Store (ISP, SIP0)
                        }
                    }

                    If (And (FLAG, One))
                    {
                        Store (SDMA (DMA0, RPS0, DMM0), DMAT)
                        Store (PCT, SCT0)
                        Store (PCB, SCB0)
                        Store (UDME, UDM2)
                        Store (UDMT, SUM0)
                        Store (TDMA, TDM0)
                    }
                    Else
                    {
                        Store (Zero, UDM2)
                    }

                    If (And (FLAG, 0x04))
                    {
                        Store (SDMA (DMA1, RPS1, DMM1), DMAT)
                        Store (PCT, SCT1)
                        Store (PCB, SCB1)
                        Store (UDME, UDM3)
                        Store (UDMT, SUM1)
                        Store (TDMA, TDM1)
                    }
                    Else
                    {
                        Store (Zero, UDM3)
                    }

                    If (And (FLAG, 0x02))
                    {
                        Store (One, SIE0)
                    }

                    If (And (FLAG, 0x08))
                    {
                        Store (One, SIE1)
                    }
                }

                Device (MAST)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA0, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03,
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF             
                        })
                        CreateByteField (ATA0, One, PIO0)
                        CreateByteField (ATA0, 0x08, DMA0)
                        Store (TPI0, PIO0)
                        Or (PIO0, 0x08, PIO0)
                        If (And (UDM2, One))
                        {
                            Store (TDM0, DMA0)
                            Or (DMA0, 0x40, DMA0)
                        }
                        Else
                        {
                            Store (TPI0, DMA0)
                            If (LNotEqual (DMA0, Zero))
                            {
                                Subtract (DMA0, 0x02, DMA0)
                            }

                            Or (DMA0, 0x20, DMA0)
                        }

                        Return (ATA0)
                    }
                }

                Device (SLAV)
                {
                    Name (_ADR, One)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA1, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03,
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF             
                        })
                        CreateByteField (ATA1, One, PIO1)
                        CreateByteField (ATA1, 0x08, DMA1)
                        Store (TPI1, PIO1)
                        Or (PIO1, 0x08, PIO1)
                        If (And (UDM3, One))
                        {
                            Store (TDM1, DMA1)
                            Or (DMA1, 0x40, DMA1)
                        }
                        Else
                        {
                            Store (TPI1, DMA1)
                            If (LNotEqual (DMA1, Zero))
                            {
                                Subtract (DMA1, 0x02, DMA1)
                            }

                            Or (DMA1, 0x20, DMA1)
                        }

                        Return (ATA1)
                    }
                }
            }
        }
    }
}

